#include "iface.h"
#include "node1.h"

extern int kernel_init (void);
extern int kernel_idle (void);


#define CLCKFREQ 10000000       /* Internal timer clock frequency     */
#define TICKTIME     1000       /* K_TICK period in microseconds      */
#define TICKFREQ     1000       /* K_TICK frequency in Hertz          */
#define TICKUNIT    10000       /* K_TICK in CLCKFREQ units           */

#define NTIMERS  20            /* number of timers                   */
#define NCPACKS  20            /* number of command & mail packets   */
#define NWPACKS  20            /* number of multiple wait packets    */


/* ----------------------------------------------------------------------*/

#ifdef CONIDRV
K_QUEUE  coniq     = CONIQ;
#endif

#ifdef CONODRV
K_QUEUE  conoq     = CONOQ;
#endif

#ifdef CONRES
K_RES    conres    = CONRES;
#endif

#ifdef HOSTRES
K_RES    hostres   = HOSTRES;
#endif

#ifdef TLDEBUG
K_SEMA   debuggo   = DEBUGGO;
#include "_stdio.h"
static void *p1 = (void *) sprintf;    /* forward references for linker */
static void *p2 = (void *) server_pollkey;
static void *p3 = (void *) server_putchar;
#endif

#ifdef GRAPHDRV
K_RES    graphres  = GRAPHRES;
K_QUEUE  graphoq   = GRAPHOQ;
K_QUEUE  graphiq   = GRAPHIQ;
#else
#ifdef TLDEBUG
 void SaveScreen (void) {}
 void RestScreen (void) {}
#endif
#endif


 int ticktime = TICKTIME;
 int tickfreq = TICKFREQ;
 int tickunit = TICKUNIT;

 int TIM_ASIZE = NTIMERS;
 int KCP_ASIZE = NCPACKS;
 int WTM_ASIZE = NWPACKS;

 K_TIMER    TIM_ARRAY [NTIMERS];
 K_ARGS     KCP_ARRAY [NCPACKS];
 WTM_STRUCT WTM_ARRAY [NWPACKS];


/* ----------------------------------------------------------------------*/


 extern void timer0_isr (void);


 int main ()
   {
   /* initialise the bus configuration */
   *((unsigned *) 0x808064) = 0x000f0600;
   *((unsigned *) 0x808060) = 0x00000000; 

   /* start the kernel */
   kernel_init ();

   /* start the ticks interrupt */
   timer0_init (tickunit);
   KS_EnableISR (8, timer0_isr);

   /* initialise host interface */
   tor31host ();

   /* start tasks having EXE group attribute */
   KS_StartG (EXE_GROUP);

   /* continue as the idle task */
   kernel_idle ();

   return 0;
   }


/* ----------------------------------------------------------------------*/
