#include "iface.h"
#include "_stdio.h"
#include "siggraph.h"
#include "fft.h"
#include "math.h"
#include "node1.h"
#include "defines.h"


 void fftplot (void)
   {
   SIGGRAPH       *G;
   FLOAT32SIGNAL  *S1, *N, *S2;
   CFLOAT32SIGNAL *C;
   FLOAT32         Fs = 8000.0, ph1, fr1;
   FLOAT32FFT     *F;
   int             i, ctrl;
   

   S1 = FLOAT32SignalAlloc (256, Fs);
   S2 = FLOAT32SignalAlloc (256, Fs);
   C  = CFLOAT32SignalAlloc (128, Fs);
   
   G = AllocSIGGRAPH ();
   
   TileScreen (&G, 1, FFT_X1, FFT_Y1, FFT_X2, FFT_Y2);

   SetGraphSigBgColor (G, BLACK);
   SetGraphXRange (G, 0.0, 1.0);
   SetGraphYRange (G, -0.5, 0.5);

   KS_TestW (FFT_STOP);

   ph1 = 0.0;
   fr1 = 500.0;

   F = FLOAT32FFTAlloc (256);
   FLOAT32FFTInit (F);

   while (1)
     {
     if (KS_Test (FFT_STOP) == RC_OK)
       {
       KS_Signal (STOP_ACK);
       KS_TestW (FFT_STOP);
       }

     ph1 = FLOAT32SignalSineGen (256, S1, fr1, ph1, 1.0);
     fr1 += 250.0;
     if (fr1 >= 2000.0) fr1 = 250.0;

     FLOAT32SignalGaussNoiseGen (256, S2, 0.0, 1.0);
     FLOAT32VecSumC (S1->Vect, S2->Vect, S2->Vect);

     FLOAT32VecToCAlt (S2->Vect, C->Vect);

     FLOAT32FFTFwdCore (F, C->Vect);
     FLOAT32FFT1RFwdPost (F, C->Vect);

     KS_LockW (GRAPHRES);
     CFLOAT32SignalPlot (G, C, PO_CLEAR | PO_REAL | PO_IMAG,
                         LIGHTGREEN, LIGHTRED);
     KS_Unlock (GRAPHRES);

     KS_Sleep(100);
     }
   }


