#include "iface.h"
#include "grint.h"
#include "node1.h"
#include "defines.h"
#include "_stdio.h"


 static int x1;


 static void wlmon_update (int k)
   {
   FILLSTYLE F;
   int       x0;

   x0 = WLMON_X1 + 19 + ((k * 70) / 1000);

   if (x0 != x1)
     {
     KS_LockW (GRAPHRES);
     F.color = (x0 > x1) ? LIGHTRED : BLACK;
     F.type  = SOLID_FILL;
     setfillstyle (&F);
     bar (x1, WLMON_Y1 + 40, x0, WLMON_Y1 + 48);
     KS_Unlock (GRAPHRES);
     x1 = x0;
     }
   }


 static void wlmon_init ()
   {
   int       i, tmp;
   FILLSTYLE F;

   KS_LockW (GRAPHRES);

   F.color = BLACK;
   F.type  = SOLID_FILL;
   setfillstyle (&F);
   bar (WLMON_X1, WLMON_Y1, WLMON_X2, WLMON_Y2);

   setcolor (WHITE);
   rectangle (WLMON_X1, WLMON_Y1, WLMON_X2, WLMON_Y2);
   moveto (WLMON_X1, WLMON_Y1 + 26);
   lineto (WLMON_X2, WLMON_Y1 + 26);

   outtextxy (WLMON_X1 + 5, WLMON_Y1 + 5,  "Workload");
   outtextxy (WLMON_X1 + 5, WLMON_Y1 + 15, "on C30 (%)");

   setcolor (LIGHTGREEN);
   moveto (WLMON_X1 + 19, WLMON_Y1 + 56);
   lineto (WLMON_X1 + 89, WLMON_Y1 + 56);
   for (i = 0; i <= 70; i += 35)
     {
     tmp = WLMON_X1 + 19 + i;
     moveto (tmp, WLMON_Y1 + 56);
     lineto (tmp, WLMON_Y1 + 64);
     }
   for (i = 0; i < 70; i += 7)
     {
     tmp = WLMON_X1 + 19 + i;
     moveto (tmp, WLMON_Y1 + 56);
     lineto (tmp, WLMON_Y1 + 60);
     }
   outtextxy (WLMON_X1 +  5, WLMON_Y1 + 41, "1");
   outtextxy (WLMON_X1 + 15, WLMON_Y1 + 67, "0");
   outtextxy (WLMON_X1 + 46, WLMON_Y1 + 67, "50");
   outtextxy (WLMON_X1 + 73, WLMON_Y1 + 67, "100");

   KS_Unlock (GRAPHRES);

   x1 = WLMON_X1 + 19;
   }


 void wlmon (void)
   {
   wlmon_init ();

   KS_SetWlper (300);
   KS_StartTimer (KS_AllocTimer (), 150, 150, WL_TIME);

   while (1)
     {
     if (KS_Test (WLM_STOP) == RC_OK)
       {
       wlmon_update (0);
       KS_Signal (STOP_ACK);
       KS_TestW (WLM_STOP);
       KS_ResetSema (WL_TIME);
       }

     KS_Wait (WL_TIME);
     wlmon_update (KS_Workload ());
     }
   }

