#include "iface.h"
#include "grint.h"
#include "node1.h"


#define XBASE  70
#define YBASE  400
#define XSIZE  500
#define YSIZE  16

 static FILLSTYLE fillpars;
 VIEWPORT viewport;

 void wlmon (void)
   {
   int color, x0, x1;

   color = YELLOW;
   x1 = XSIZE; 

   KS_SetWlper (500);

   KS_LockW (GRAPHRES);
   fillpars.type = SOLID_FILL;
   fillpars.color = 7;
   setfillstyle (&fillpars);

   viewport.left   = 0;
   viewport.right  = 639;
   viewport.top    = 0;
   viewport.bottom = 479;
   viewport.clip   = 0;
   setviewport (&viewport);

   bar (XBASE, YBASE, XBASE+XSIZE, YBASE+YSIZE);
   KS_Unlock (GRAPHRES);

   while (1)
     {
     KS_Sleep (300);
     x0 = XSIZE * KS_Workload ()/1000;
     if (x0 != x1)   /* workload has changed */
       {

       KS_LockW (GRAPHRES);
       if (x0 > x1)  /* workload has increased, make bar longer */
	 {
	 fillpars.type = SOLID_FILL;
	 fillpars.color = color;
	 setfillstyle (&fillpars);

	 setviewport (&viewport);

	 bar (x1, YBASE, x0, YBASE+YSIZE);
	 }
       else          /* workload has decreased, make bar shorter */
	 {
	 fillpars.type = SOLID_FILL;
	 fillpars.color = 7;
	 setfillstyle (&fillpars);

	 setviewport (&viewport);

	 bar (x0, YBASE, x1, YBASE+YSIZE);
	 }
       KS_Unlock (GRAPHRES);

       x1 = x0;      /* remember current workload */
       }
     }
   }



