
/****************************************************************
	TORNADO-3x SRAM Test via Host ISA-bus Memory I/F.
	(C) MicroLAB Systems
*****************************************************************/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>
#include <ips_ut.h>


#include <t3x_h.h>

unsigned long	START_SADDR = 0x0L,
                LAST_SADDR  = 0x3ffffL;

unsigned long sa;
unsigned int page;
unsigned pass=1, ccl_type=0;
unsigned long	data,*D,data_start, data_rd,
                initial_data = 0xa5f1e251L,
		data_inc     = 0x13579bdfL;
int ex_status;

#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");


char err_mess[100], dev_name[40];
unsigned dev_id;


 main()

 { int r;

   printf("\nTORNADO-3x SRAM Test Utility via Host I/F. v.2.1\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1995\n\n");


   if(   (r=T3X_open(0x350))!=T3X_OK
      || (r=T3X_dev_name(dev_name))!=T3X_OK
      || (r=T3X_dev_id_data(&dev_id))!=T3X_OK
      || (r=T3X_set_smp_segm(0xd800))!=T3X_OK
     )
       { error:
                 T3X_err_message(r,err_mess);
	         printf("\n%s\n",err_mess);
		 goto exit;
       }

  printf("%s DSP System, s/n: #%x\n\n",
  	 dev_name,dev_id & 0xff);




   printf("start SB address [000000H..ffffffH]: ");
   START_SADDR=gethex(0L,0xffffffL,START_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   LAST_SADDR=START_SADDR-START_SADDR%0x40000L + 0x3ffffL;
   printf("end SB address   [%6lxH..ffffffH]: ",START_SADDR);
   LAST_SADDR=gethex(START_SADDR,0xffffffL,LAST_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }



   printf("\npress ESC to abort and exit to DOS ...\n\n");

   T3X_CLR_SB_ERR;

   data_start = initial_data;

   while(1)
     {
	CLEAR_CURRENT_LINE;
	printf("\rSB mode: %s    pass: %5u  ",
	       ccl_type==0 ? "BYTE": ccl_type==1 ? "W16":"W32",
               pass);

        switch(ccl_type)
	 {
	   case 0:
                   T3X_SET_SB_CCL_BYTE;
		   break;
	   case 1:
                   T3X_SET_SB_CCL_W16;
		   break;
	   default:
                   T3X_SET_SB_CCL_W32;
		   break;
	 }

           data = data_start;
           if((r=T3X_set_smp_ptr(START_SADDR*4L,&D))!=T3X_OK) goto error;
           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(((sa*4L)%T3X_SMP_LEN)==0)	
		  {
		     if((r=T3X_set_smp_ptr((sa*4L),&D))!=T3X_OK) goto error;
		     if(((sa*4L)%(2L*T3X_SMP_LEN))==0) printf("w");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. status: OK\n\n");
		         goto exit;
		       }
		  }

		*(D++)=data++;
		if(T3X_SB_ERR_DATA!=0)
		  {
		    printf("\nerror: SB error at write to SA=%lxH\n\n",sa);
		    goto exit;
		  }

	      }

           data = data_start;
           if((r=T3X_set_smp_ptr(START_SADDR*4L,&D))!=T3X_OK) goto error;
           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(((sa*4L)%T3X_SMP_LEN)==0)	
		  {
		     if((r=T3X_set_smp_ptr((sa*4L),&D))!=T3X_OK) goto error;
		     if(((sa*4L)%(2L*T3X_SMP_LEN))==0) printf("r");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. status: OK\n\n");
		         goto exit;
		       }
		  }

                data_rd=*(D++);
		if(T3X_SB_ERR_DATA!=0)
		  {
		    printf("\nerror: SB error at read from SA=%lxH\n\n",sa);
		    goto exit;
		  }


		if(data_rd!=data++)
		  {
		    printf("\nerror: SA=%lxH data_wr=%lxH  data_rd=%lxH\n\n",
			      sa, --data, data_rd );
		    goto exit;

		  };

	      }

       if(++pass>=20)
	  {
	    pass=0;
	    if(++ccl_type>=3) ccl_type=0;
	  }

       data_start += data_inc ;
      }

  exit:
    T3X_SET_SMP_RG(0);
    T3X_CLR_SB_ERR;

 }





