
/*

	Writing/Reading the T31 BANK #0 SRAM in background.

*/

#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include <t31.h>

#include <ips_ut.h>

unsigned long	START_SADDR = 0x0L,
                LAST_SADDR  = 0x3ffffL;

unsigned long sa;
unsigned int page;
unsigned pass=1, ccl_type=0;
unsigned long	data,*D,data_start, data_rd,
                initial_data = 0xa5f1e251L,
		data_inc     = 0x13579bdfL;
int ex_status;

#define CLEAR_CURRENT_LINE  printf("\r%79s\r"," ");


 main()

 {

   printf("\nTORNADO-3x Host/IF Test Utility. Memory Write/Read. v.1.1\n");
   printf("Copyright (C) MicroLAB Systems Ltd, 1995\n\n");

   printf("start SB address [000000H..ffffffH]: ");
   START_SADDR=gethex(0L,0xffffffL,START_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   LAST_SADDR=START_SADDR-START_SADDR%0x40000L + 0x3ffffL;
   printf("end SB address   [%6lxH..ffffffH]: ",START_SADDR);
   LAST_SADDR=gethex(START_SADDR,0xffffffL,LAST_SADDR,
                       CR_ENABLE,ESC_MASK,&ex_status);

   if(ex_status==ESC_MASK)
            {  CLEAR_CURRENT_LINE;
               goto exit;
            }

   printf("\npress ESC to abort and exit to DOS ...\n\n");


   T31_CLR_SB_ERR;


   data_start = initial_data;

   while(1)
     {
	CLEAR_CURRENT_LINE;
	printf("\rSB mode: %s    pass: %5u  ",
	       ccl_type==0 ? "BYTE": ccl_type==1 ? "W16":"W32",
               pass);

        switch(ccl_type)
	 {
	   case 0:
                   T31_SET_SB_CCL_BYTE;
		   break;
	   case 1:
                   T31_SET_SB_CCL_W16;
		   break;
	   default:
                   T31_SET_SB_CCL_W32;
		   break;
	 }


           data = data_start;
           T31_set_smp_ptr(START_SADDR*4L,&D);
           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(((sa*4L)%T31_SMP_LEN)==0)	
		  {
		     T31_set_smp_ptr((sa*4L),&D);
//printf("\nsmp=%x\n",inpw(0x350));
		     if(((sa*4L)%(2L*T31_SMP_LEN))==0) printf("w");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. status: OK\n\n");
		         goto exit;
		       }
		  }

		*(D++)=data++;

		if(T31_SB_ERR_DATA!=0)
		  {
		    printf("\nerror: SB error at write to SA=%lxH\n\n",sa);
		    goto exit;
		  }

	      }

           data = data_start;
           T31_set_smp_ptr(START_SADDR*4L,&D);
           for (sa=START_SADDR;sa<=LAST_SADDR;sa++)
	      {
		if(((sa*4L)%T31_SMP_LEN)==0)	
		  {
		     T31_set_smp_ptr((sa*4L),&D);
		     if(((sa*4L)%(2L*T31_SMP_LEN))==0) printf("r");

   	             if( key_pressed() && read_char()==KEY_ESC)
  		       {
		         printf("\nUser aborted. status: OK\n\n");
		         goto exit;
		       }
		  }

                data_rd=*(D++);

		if(T31_SB_ERR_DATA!=0)
		  {
T31_SET_HM_RQ;
		    printf("\nerror: SB error at read from SA=%lxH\n\n",sa);
		    goto exit;
		  }


		if(data_rd!=data++)
		  {
T31_SET_HM_RQ;
		    printf("\nerror: SA=%lxH data_wr=%lxH  data_rd=%lxH\n\n",
			      sa, --data, data_rd );
		    goto exit;

		  };

	      }




       if(++pass>=20)
	  {
	    pass=0;
	    if(++ccl_type>=3) ccl_type=0;
	  }

       data_start += data_inc ;


      }
	

   	

   exit:

    T31_SET_SMP_RG(0);
    T31_CLR_SB_ERR;

 }





