/*
	TMS320C30 Definitions.

*/


int *SIO0_GC	= (int *)0x808040;
int *SIO0_XC	= (int *)0x808042;
int *SIO0_RC	= (int *)0x808043;
int *SIO0_RXTC	= (int *)0x808044;
int *SIO0_RXTCNT= (int *)0x808045;
int *SIO0_RXTPER= (int *)0x808046;
int *SIO0_XD	= (int *)0x808048;
int *SIO0_RD	= (int *)0x80804C;

int *SIO1_GC	= (int *)0x808050;
int *SIO1_XC	= (int *)0x808052;
int *SIO1_RC	= (int *)0x808053;
int *SIO1_RXTC	= (int *)0x808054;
int *SIO1_RXTCNT= (int *)0x808055;
int *SIO1_RXTPER= (int *)0x808056;
int *SIO1_XD	= (int *)0x808058;
int *SIO1_RD	= (int *)0x80805C;

int *TM1_GC	= (int *)0x808030;
int *TM1_CNT	= (int *)0x808034;
int *TM1_PER	= (int *)0x808038;
int *TM0_GC	= (int *)0x808020;
int *TM0_CNT	= (int *)0x808024;
int *TM0_PER	= (int *)0x808028;

int *PBUS_C	= (int *)0x808064;
int *XBUS_C	= (int *)0x808060;
int *STB0_C	= (int *)0x808064;
int *STB1_C	= (int *)0x808068;
int *IOSTB_C	= (int *)0x808060;


#define INT_ENABLE		asm("	or    2000h,st")
#define INT_DISABLE		asm("	and  ~2000h,st")
#define INT_LEVEL		asm("	and  ~4000h,st")
#define INT_EDGE		asm("	or    4000h,st")

#define CACHE_ENABLE	       {asm("	and  ~(800h | 400h),st");asm("	or    (1000h | 800h),st");}
#define	CACHE_DISABLE		asm("	and  ~800h,st")	
#define	CACHE_FREEZE		asm("	or    400,st")
#define	CACHE_UNFREEZE		asm("	and  ~400,st")

#define	EXT_INT_ENABLE(i) 	asm("   or   (1<<" #i "),ie")
#define	EXT_INT_DISABLE(i)	asm("	and ~(1<<" #i "),ie")
#define	EXT_IRQ_CLEAR(i)	asm("	and ~(1<<" #i "),if")
#define	EXT_IRQ_SET(i)		asm("	or   (1<<" #i "),if")


#define	SX0_INT_ENABLE		asm("	or   10h,ie")
#define	SX0_INT_DISABLE		asm("	and ~10h,ie")
#define	SR0_INT_ENABLE		asm("	or   20h,ie")
#define	SR0_INT_DISABLE		asm("	and ~20h,ie")
#define	SX1_INT_ENABLE		asm("	or   40h,ie")
#define	SX1_INT_DISABLE		asm("	and ~40h,ie")
#define	SR1_INT_ENABLE		asm("	or   80h,ie")
#define	SR1_INT_DISABLE		asm("	and ~80h,ie")

#define	SX0_IRQ_CLEAR		asm("	and ~10h,if")
#define	SX0_IRQ_SET		asm("	or   10h,if")
#define	SR0_IRQ_CLEAR		asm("	and ~20h,if")
#define	SR0_IRQ_SET		asm("	or   20h,if")
#define	SX1_IRQ_CLEAR		asm("	and ~40h,if")
#define	SX1_IRQ_SET		asm("	or   40h,if")
#define	SR1_IRQ_CLEAR		asm("	and ~80h,if")
#define	SR1_IRQ_SET		asm("	or   80h,if")


#define	TM0_INT_ENABLE		asm("	or   100h,ie")
#define	TM0_INT_DISABLE		asm("	and ~100h,ie")
#define	TM1_INT_ENABLE		asm("	or   200h,ie")
#define	TM1_INT_DISABLE		asm("	and ~200h,ie")

#define	TM0_IRQ_SET		asm("	or   100h,if")
#define	TM0_IRQ_CLEAR		asm("	and ~100h,if")
#define	TM1_IRQ_SET		asm("	or   200h,if")
#define	TM1_IRQ_CLEAR		asm("	and ~200h,if")

